﻿Type=Class
Version=2.8
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private pnMain As Pane
	Private pnPanel As Pane
	Private pnFrame As Pane
	Private cWdt, cHgt As Double
	Private ScaleW As Double 
	Private ScaleH As Double 
	Private tmCompass As Timer 
	Private CompassValue, CompassOldValue As Int
	Private Cardinals(361) As String
	Private cvPanel As Canvas
	Private fnt As Font 
	Private PanelColor As Paint = fx.Colors.RGB(255,255,255)
	Private LetterColor As Paint = fx.Colors.DarkGray 
	Private FrameColor As Paint =  fx.Colors.RGB(180,180,180)
	Private FrameStroke As Short = 5  
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Wdt As Double, Hgt As Double)
	cWdt = Wdt
	cHgt = Hgt
	pnMain.Initialize("")
	pnPanel.Initialize("")
	pnFrame.Initialize("")
	tmCompass.Initialize("tmCompass", 10)
	tmCompass.Enabled = False 
	cvPanel.Initialize("")
	makeCompass	
End Sub
Public Sub showCompassH(frm As Form, lft As Int, Tp As Int)
	frm.RootPane.AddNode(pnMain,lft , Tp, -1, -1)
End Sub
Public Sub SetValue(vl As Double)
	CompassValue = vl
	tmCompass.Enabled =True
End Sub
Private Sub makeCompass
	'scale factors
	ScaleW= 200/cWdt
	ScaleH = 40/cHgt
	'resizes main frame
	pnMain.PrefHeight = cHgt
	pnMain.PrefWidth =  cWdt
	'*******  creates the cardinal points
    For i = 1 To 359
        Select Case i
            Case 15, 30, 60, 75, 105, 120, 150, 165, 195, 210, 240, 255, 285, 300, 330, 345
                Cardinals(i) = i
            Case Else
        End Select
    Next
    Cardinals(0) = "N"
    Cardinals(45) = "NE"
    Cardinals(90) = "E"
    Cardinals(135) = "SE"
    Cardinals(180) = "S"
    Cardinals(225) = "SW"
    Cardinals(270) = "W"
    Cardinals(315) = "NW"
    Cardinals(360) = "N"
	pnFrame_Style
	pnPanel_Style	
	pnMain.AddNode(pnPanel,0,0, cWdt, cHgt)
	pnMain.AddNode(pnFrame,0,0, cWdt, cHgt)
	cWdt= cWdt - FrameStroke*2
	cHgt = cHgt - FrameStroke * 2
	pnMain.AddNode(cvPanel, FrameStroke, FrameStroke, cWdt, cHgt)
	DrawPanel
End Sub
Private Sub pnPanel_Style
	Dim RGB(4) As Int = getRGB(fx.Colors.To32Bit(PanelColor))
	Dim Alpha As Double = RGB(0)/255
	Dim stStr As String ="rgba(" 
	For i = 1 To 3
		stStr = stStr & RGB(i) & ", "
	Next
	stStr = stStr & Alpha & ")"
	pnPanel.Style ="-fx-background-color: " & stStr & ";-fx-effect: innershadow( three-pass-box , #000000 , 35.0 , 0.45 , 0.0, 0.0 );"
End Sub
Private Sub pnFrame_Style
	Dim RGB(4) As Int = getRGB(fx.Colors.To32Bit(FrameColor))
	Dim Alpha As Double = RGB(0)/255
	Dim stStr As String ="rgba(" 
	For i = 1 To 3
		stStr = stStr & RGB(i) & ", "
	Next
	stStr = stStr & Alpha & ")"
	pnFrame.Style= "-fx-border-color: " & stStr & ";-fx-border-width: " & FrameStroke & ";"
End Sub
Private Sub DrawPanel
    Dim x As Double, y As Double, TickCount As Short, TickVal As Short
    Dim cStart As Short, cEnd As Short, PicWid As Double, Stroke As Short
    Dim Radius As String, strk(4) As Double, cValue As Int
	fnt = fx.CreateFont("system", 13/ScaleH,True,False)
	
	cValue = CompassOldValue Mod 360
    cStart = cValue - 30
    cEnd = cValue + 30
    If cStart < 0 Then cStart = 360 + cStart
    If cEnd > 360 Then cEnd = 360 - cEnd
	strk(0)= 13/ScaleH
	strk(1)= 10/ScaleH
	strk(2)= 7/ScaleH
	strk(3)= 25/ScaleH
	
	cvPanel.ClearRect(0,0,cWdt,cHgt)
    PicWid = cWdt / 60
    TickVal = cStart
	For TickCount = 0 To 60
		x = PicWid * TickCount
		If TickCount = 30 Then
            cvPanel.DrawLine(x,1, x, cHgt-1,fx.Colors.Red,2)
 		Else
            Stroke = TickVal Mod 10
            If Stroke = 0 Then cvPanel.DrawLine(x,0,x,strk(0), LetterColor, 0.8)
            Stroke = TickVal Mod 5
            If Stroke = 0 Then
                cvPanel.DrawLine(x,0,x,strk(1),LetterColor,0.8)
            Else
				cvPanel.DrawLine(x,0,x,strk(2),LetterColor,0.8)
            End If
        End If		
        If Cardinals(TickVal) <> "" Then
			cvPanel.DrawText(Cardinals(TickVal), x ,strk(3),fnt,LetterColor , "CENTER")
        End If
		
        TickVal = TickVal + 1
        If TickVal > 360 Then TickVal = TickVal - 360
	Next
End Sub
Public Sub Change_LetterColor(clr As Paint)
	LetterColor = clr
	DrawPanel
End Sub
Public Sub Change_PanelColor(clr As Paint)
	PanelColor = clr
	pnPanel_Style
End Sub
Public Sub Change_FrameColor(clr As Paint)
	FrameColor = clr
	pnFrame_Style	
End Sub
Public Sub Change_FrameStroke(S As Short)
	If S = FrameStroke Then Return
	S = Max(Min(15, S), 0)
	cWdt= cWdt + FrameStroke*2
	cHgt = cHgt + FrameStroke * 2
	cvPanel.RemoveNodeFromParent 
	pnPanel.RemoveNodeFromParent 
	FrameStroke = S
	cWdt= cWdt - FrameStroke * 2
	cHgt = cHgt - FrameStroke * 2
	ScaleH= 40/cHgt
	pnMain.AddNode(pnPanel,FrameStroke,FrameStroke, cWdt, cHgt)
	pnMain.AddNode(cvPanel, FrameStroke, FrameStroke, cWdt, cHgt)
	pnFrame_Style
	pnPanel_Style
	DrawPanel	
End Sub
Private Sub tmCompass_Tick
	If CompassValue = CompassOldValue Then
		tmCompass.Enabled = False
		Return
	End If
	Dim stp As Double
	If Abs(CompassValue - CompassOldValue) > 180 Then 
		If CompassValue > CompassOldValue Then
			stp=-1
		Else
			stp =1
		End If
	Else
		If CompassValue > CompassOldValue Then
			stp=1
		Else
			stp = -1
		End If	
	End If
	CompassOldValue = CompassOldValue + stp
	If CompassOldValue < 0 Then CompassOldValue = 359
	If CompassOldValue > 360 Then CompassOldValue = 1
	DrawPanel
End Sub
Public Sub getRGB(rgb_Clr As Int) As Int()
    Dim res(4) As Int
    res(0) = Bit.UnsignedShiftRight(Bit.AND(rgb_Clr, 0xff000000), 24)	'Alpha
    res(1) = Bit.UnsignedShiftRight(Bit.AND(rgb_Clr, 0xff0000), 16)		'Red
    res(2) = Bit.UnsignedShiftRight(Bit.AND(rgb_Clr, 0xff00), 8)		'Green
	res(3) = Bit.AND(rgb_Clr, 0xff)										'Blue
    Return res 
End Sub