﻿Type=Class
Version=2.8
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private pnMain As Pane
	Private Center As Double
	Private TDiam As Double 
	Private pnPanel As JavaObject 
	Private cvPanel As Canvas 
	Private cMold As JavaObject 
	Private cCent As JavaObject 
	Private Indicator As JavaObject 
	Private Scale As Double
	Private tmCompass As Timer 
	Private CompassValue, CompassOldValue As Int
	Private turn As Boolean =  False 
	Private flgturn As Boolean 
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Diam As Double)
	TDiam = Diam
	pnMain.Initialize("")
	cvPanel.Initialize("")
	pnMain.PrefHeight = TDiam
	pnMain.PrefWidth = TDiam
	Center = TDiam/2
	tmCompass.Initialize("tmCompass", 10)
	tmCompass.Enabled = False 
	makeCompass
End Sub
Public Sub setTurn(tn As Boolean)
	If turn = tn Then Return
	SetValue(0.0)
	flgturn= True

End Sub
Private Sub sturn()
	turn = Not(turn)
	flgturn = False
End Sub
Public Sub SetValue(vl As Double)
	CompassValue = vl
	tmCompass.Enabled =True
End Sub
Private Sub makeCompass
	Scale = 240/TDiam
	Dim Radius As Double
	Dim Stp(2) As JavaObject 
	Dim SList As List
	SList.Initialize
	
	'******** creates innerShadow effect
	Dim Effect As JavaObject 
	Effect.InitializeNewInstance("javafx.scene.effect.InnerShadow",Null)
	Effect.RunMethod("setChoke",Array(0.31))
	Effect.RunMethod("setRadius", Array(34.5))
	Effect.RunMethod("setHeight", Array(120.0/Scale))
	Effect.RunMethod("setWidth", Array(120.0/Scale))
	
	'******* create background panel
	Radius = 110/Scale
	pnPanel.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	pnPanel.RunMethod("setFill", Array(fx.Colors.White ))
	pnPanel.RunMethod("setEffect",Array(Effect))
	
	'****** creates outer frame
	Radius = 120/Scale
	Dim strkWdt As Double = 20/Scale
	cMold.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	cMold.RunMethod("setFill", Array(fx.Colors.Transparent))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeType")
	cMold.RunMethod("setStrokeType",Array As Object(JO.RunMethod("valueOf",Array("INSIDE"))))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeLineJoin")
	cMold.RunMethod("setStrokeLineJoin",Array As Object(JO.RunMethod("valueOf",Array("BEVEL"))))
	cMold.RunMethod("setStrokeWidth",Array (strkWdt))

	'******** creates LinearGradient effect
	Dim LinearGradient As JavaObject 
	Dim Stp(2) As JavaObject 
	Stp(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(242, 236, 236)))
	Stp(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(47, 45, 45)))
	SList.Clear 
	SList.Add(Stp(0))
	SList.Add(Stp(1))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	LinearGradient.InitializeNewInstance("javafx.scene.paint.LinearGradient", Array(0.4476190476190476, 0.34285714285714286, 1.0, 1.0, True,JO.RunMethod("valueOf",Array As Object ("NO_CYCLE")),SList))
	
	cMold.RunMethod("setStroke", Array(LinearGradient))
	
	'******** creates Lighting effect
	Dim Effect As JavaObject 
	Effect.InitializeNewInstance("javafx.scene.effect.Lighting",Null)
	Effect.RunMethod("setDiffuseConstant",Array(1.0))
	Effect.RunMethod("setSpecularConstant",Array(0.3))
	Effect.RunMethod("setSpecularExponent",Array(22.8))
	Effect.RunMethod("setSurfaceScale",Array(2.5))
	
	cMold.RunMethod("setEffect",Array(Effect))
	
	'***** add objects in Pane
	pnMain.AddNode(pnPanel,-1, -1, -1, -1)
	pnMain.AddNode(cvPanel, 0,0,TDiam,TDiam)
	pnMain.AddNode(cMold,-1, -1, -1, -1)
	
	'*******creates indicator
	Radius = 75/Scale
	Dim Points(8) As Double
	Points(0) = Center 
	Points(1) = Center - 50/Scale
	Points(2) = 7/Scale + Center
	Points(3) = Center
	Points(4) = Center
	Points(5) = 50/Scale + Center 
	Points(6) = Center - 7/Scale
	Points(7) = Center 
	Indicator.InitializeNewInstance("javafx.scene.shape.Polygon",Array(Points))
	
	'******** creates LinearGradient effect
	Dim LinearGradient As JavaObject 
	Dim Stp(2) As JavaObject 
	Stp(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(7, 119, 178)))
	Stp(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(218, 11, 11)))
	SList.Clear 
	SList.Add(Stp(0))
	SList.Add(Stp(1))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	LinearGradient.InitializeNewInstance("javafx.scene.paint.LinearGradient", Array(1.0, 0.0, 1.0, 1.0, True,JO.RunMethod("valueOf",Array As Object ("NO_CYCLE")),SList))
	Indicator.RunMethod("setFill", Array(LinearGradient))
	
	'******** creates innerShadow effect
	Dim Effect As JavaObject 
	Effect.InitializeNewInstance("javafx.scene.effect.InnerShadow",Null)
	Effect.RunMethod("setChoke",Array(0.42))
	Effect.RunMethod("setRadius", Array(13.7075))
	Effect.RunMethod("setHeight", Array(41.76))
	Effect.RunMethod("setWidth", Array(15.07))
	Effect.RunMethod("setColor", Array(fx.Colors.RGB(64, 64, 64)))
	Indicator.RunMethod("setEffect",Array(Effect))

	'***** add Indicator in Pane
	pnMain.AddNode(Indicator,-1 ,-1 , -1, -1)

	DrawPanel

	Radius = 10/Scale
	cCent.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	cCent.RunMethod("setFill", Array(fx.Colors.RGB(233,233,233)))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeType")
	cCent.RunMethod("setStrokeType",Array As Object(JO.RunMethod("valueOf",Array("INSIDE"))))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeLineJoin")
	cMold.RunMethod("setStrokeLineJoin",Array As Object(JO.RunMethod("valueOf",Array("BEVEL"))))
	strkWdt = 2/Scale
	cCent.RunMethod("setStrokeWidth",Array (strkWdt))
	cCent.RunMethod("setStroke", Array(fx.Colors.DarkGray))
	pnMain.AddNode(cCent,-1 ,-1 , -1, -1)
	SetValue(0)
End Sub
Private Sub DrawPanel
    Dim  TickCount As Short
    Dim  Stroke As Short
    Dim  strk(5) As Double
	strk(0)= 13/Scale
	strk(1)= 28/Scale
	strk(2)= 7/Scale
	strk(3)= 25/Scale	
	strk(4)= 43/Scale
	Dim fz As Double = (11/Scale) 
	Dim fz1 As Double = (13/Scale) 
	Dim f As Font = fx.CreateFont("System", fz,False,False)
	Dim f1 As Font = fx.CreateFont("System", fz1,True,False)
	Dim NewPt(2) As PointApi 
	Dim Radius As Double  = 95/Scale
	For TickCount = 0 To 359 
		NewPt(0)= new_pt(TickCount,Radius,Center,Center)
    	Stroke = TickCount Mod 10
        If Stroke = 0 Then 
			If (TickCount/10)Mod 2 <>0 Then
				NewPt(1) = new_pt(TickCount,Radius - strk(1),Center,Center)
			Else
				NewPt(1) = new_pt(TickCount,Radius - strk(0),Center,Center)
			End If
			cvPanel.DrawLine(NewPt(0).x, NewPt(0).y ,NewPt(1).x,NewPt(1).y,fx.Colors.DarkGray,0.5)
		Else If TickCount Mod 2 = 0 Then
			NewPt(1) = new_pt(TickCount,Radius - strk(2),Center,Center)
			cvPanel.DrawLine(NewPt(0).x, NewPt(0).y ,NewPt(1).x,NewPt(1).y,fx.Colors.DarkGray,0.5)
		End If
        Stroke = TickCount Mod 20
        If Stroke = 0 Then
			NewPt(1) = new_pt(360-TickCount,Radius - strk(3),Center,Center)
			cvPanel.DrawTextRotated(TickCount, NewPt(1).x , NewPt(1).y, f, fx.Colors.DarkGray, "CENTER", TickCount)
		End If
		Select Case TickCount
			Case 0
				NewPt(1) = new_pt(360-TickCount,Radius - strk(4),Center,Center)
				cvPanel.DrawTextRotated("N",NewPt(1).x , NewPt(1).y, f1, fx.Colors.DarkGray, "CENTER", TickCount)
			Case 45
				NewPt(1) = new_pt(360-TickCount,Radius - strk(4),Center,Center)
				cvPanel.DrawTextRotated("NE",NewPt(1).x , NewPt(1).y, f1, fx.Colors.DarkGray, "CENTER", TickCount)
			Case 90
				NewPt(1) = new_pt(360-TickCount,Radius - strk(4),Center,Center)
				cvPanel.DrawTextRotated("E",NewPt(1).x , NewPt(1).y, f1, fx.Colors.DarkGray, "CENTER", TickCount)
			Case 135
				NewPt(1) = new_pt(360-TickCount,Radius - strk(4),Center,Center)
				cvPanel.DrawTextRotated("SE",NewPt(1).x , NewPt(1).y, f1, fx.Colors.DarkGray, "CENTER", TickCount)
			Case 180
				NewPt(1) = new_pt(360-TickCount,Radius - strk(4),Center,Center)
				cvPanel.DrawTextRotated("S",NewPt(1).x , NewPt(1).y, f1, fx.Colors.DarkGray, "CENTER", TickCount)
			Case 225
				NewPt(1) = new_pt(360-TickCount,Radius - strk(4),Center,Center)
				cvPanel.DrawTextRotated("SW",NewPt(1).x , NewPt(1).y, f1, fx.Colors.DarkGray, "CENTER", TickCount)
			Case 270
				NewPt(1) = new_pt(360-TickCount,Radius - strk(4),Center,Center)
				cvPanel.DrawTextRotated("W",NewPt(1).x , NewPt(1).y, f1, fx.Colors.DarkGray, "CENTER", TickCount)
			Case 315
				NewPt(1) = new_pt(360-TickCount,Radius - strk(4),Center,Center)
				cvPanel.DrawTextRotated("NW",NewPt(1).x , NewPt(1).y, f1, fx.Colors.DarkGray, "CENTER", TickCount)

		End Select
	Next
	cvPanel.DrawCircle(Center,Center,66/Scale,fx.Colors.DarkGray,False,0.5)
End Sub
Public Sub showCompass(frm As Form, lft As Int, Tp As Int)
	frm.RootPane.AddNode(pnMain,lft , Tp, -1, -1)
End Sub
Private Sub new_pt(nAngle As Double, r As Double, CX  As Double, CY As Double ) As PointApi 
        Dim AngleRad As Double
		Dim pt As PointApi 
		nAngle = 90 + nAngle
        If nAngle > 360 Then nAngle = nAngle - 360
        AngleRad = nAngle * cPI / 180 'convert to rad
        If AngleRad < 0 Then AngleRad = 6.283 + AngleRad
        pt.x = CX + (r) * Cos(AngleRad)
        pt.Y  = CY - (r) * Sin(AngleRad)
        Return pt
End Sub
Private Sub tmCompass_Tick
	If CompassValue = CompassOldValue Then
		If flgturn Then sturn
		tmCompass.Enabled = False
		Return
	End If
	Dim stp As Double
	If Abs(CompassValue - CompassOldValue) > 180 Then 
		If CompassValue > CompassOldValue Then
			stp=-1
		Else
			stp =1
		End If
	Else
		If CompassValue > CompassOldValue Then
			stp=1
		Else
			stp = -1
		End If	
	End If
	CompassOldValue = CompassOldValue + stp
	If CompassOldValue < 0 Then CompassOldValue = 359
	If CompassOldValue > 360 Then CompassOldValue = 1
	If turn Then
		tx="-fx-rotate: " & (360-CompassOldValue) & ";"
		cvPanel.Style = tx
	Else
		tx="-fx-rotate: " & CompassOldValue & ";"
		Indicator.RunMethod("setStyle", Array(tx))
	End If
End Sub