﻿Type=Class
Version=2.8
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private pnMain As Pane
	Private Center As Double
	Private TDiam As Double 
	Private pnPanel As JavaObject 
	Private cvPanel As Canvas 
	Private cMold As JavaObject 
	Private Scale As Double
	Private cRadar As Double
	Private RadarColor As Paint = fx.Colors.RGB(0, 85, 135)
	Private mSat As  Short
	Private lbSat() As Label 
	Private strColor(5) As String
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Diam As Double, maxSat As Short)
	TDiam = Diam
	Scale = 240/TDiam
	Dim fz As Double = 10/Scale
	Private f As Font = fx.CreateFont("Arial", fz,False,False)
	mSat = maxSat
	Dim lbSat(mSat) As Label 
	pnMain.Initialize("")
	cvPanel.Initialize("")
	pnMain.PrefHeight = TDiam
	pnMain.PrefWidth = TDiam
	Center = TDiam/2
	strColor(0)  = "#00FF00"
	strColor(1) = "#40BF00"
	strColor(2) = "#808000"
	strColor(3) = "#BF4000"
	strColor(4) = "#FF0000"	
	For i = 0 To 11
		lbSat(i).Initialize("")
		lbSat(i).Font = f
		lbSat(i).TextColor=fx.Colors.White
		'lbSat(i).Visible=False
	Next	
	makeSatPos
End Sub
Public Sub SetValue(satelliteNumber As Short, pseudoRandomCode As Short, elevation As Short, azimuth As Short, signalToNoiseRatio As Short)
	'elevation 0 to 90	
	'azimuth 0 to 360
	'signalToNoiseRatio 0 to 99
	satelliteNumber=satelliteNumber-1
	elevation  = Max(Min(90,elevation),0)
	azimuth  = Max(Min(360, azimuth),0)
	signalToNoiseRatio  = Max(Min(99, signalToNoiseRatio),0)
	If signalToNoiseRatio=0 Then
		lbSat(satelliteNumber).Visible =False
		Return
	End If
	Dim clr As Short = Abs((signalToNoiseRatio+1)-100)/20
	If clr>4 Then clr = 4
	Dim angle As Double = 360-azimuth
	Dim pt As PointApi
	Dim Raio As Double = cRadar-((cRadar/90)*elevation)
	pt = new_pt(angle, Raio, Center, Center)
	lbSat(satelliteNumber).Style="-fx-background-color: " & strColor(clr) & "; -fx-background-radius: 3;"
	lbSat(satelliteNumber).Text = " " & pseudoRandomCode & " " 
	lbSat(satelliteNumber).Top = pt.y - lbSat(satelliteNumber).Height / 2
	lbSat(satelliteNumber).Left = pt.x-lbSat(satelliteNumber).Width / 2
	lbSat(satelliteNumber).visible=True	
End Sub
Private Sub makeSatPos
	Dim Radius As Double
	Dim SList As List
	SList.Initialize
	Dim Stp(2) As JavaObject 
	Radius = 110/Scale
	Dim Effect As JavaObject 
	Effect.InitializeNewInstance("javafx.scene.effect.InnerShadow",Null)
	Effect.RunMethod("setChoke",Array(0.31))
	Effect.RunMethod("setRadius", Array(34.5))
	Effect.RunMethod("setHeight", Array(120.0/Scale))
	Effect.RunMethod("setWidth", Array(120.0/Scale))
	pnPanel.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	pnPanel.RunMethod("setFill", Array(fx.Colors.White ))
	pnPanel.RunMethod("setEffect",Array(Effect))

	Radius = 120/Scale
	Dim strkWdt As Double = 20/Scale
	cMold.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	cMold.RunMethod("setFill", Array(fx.Colors.Transparent))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeType")
	cMold.RunMethod("setStrokeType",Array As Object(JO.RunMethod("valueOf",Array("INSIDE"))))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeLineJoin")
	cMold.RunMethod("setStrokeLineJoin",Array As Object(JO.RunMethod("valueOf",Array("BEVEL"))))
	cMold.RunMethod("setStrokeWidth",Array (strkWdt))
	Dim LinearGradient As JavaObject 
	Dim Stp(2) As JavaObject 
	Stp(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(242, 236, 236)))
	Stp(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(47, 45, 45)))
	SList.Clear 
	SList.Add(Stp(0))
	SList.Add(Stp(1))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	LinearGradient.InitializeNewInstance("javafx.scene.paint.LinearGradient", Array(0.4476190476190476, 0.34285714285714286, 1.0, 1.0, True,JO.RunMethod("valueOf",Array As Object ("NO_CYCLE")),SList))
	cMold.RunMethod("setStroke", Array(LinearGradient))
	Dim Effect As JavaObject 
	Effect.InitializeNewInstance("javafx.scene.effect.Lighting",Null)
	Effect.RunMethod("setDiffuseConstant",Array(1.0))
	Effect.RunMethod("setSpecularConstant",Array(0.3))
	Effect.RunMethod("setSpecularExponent",Array(22.8))
	Effect.RunMethod("setSurfaceScale",Array(2.5))
	cMold.RunMethod("setEffect",Array(Effect))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeLineJoin")
	cMold.RunMethod("setStrokeLineJoin",Array As Object(JO.RunMethod("valueOf",Array("BEVEL"))))
	pnMain.AddNode(pnPanel,-1, -1, -1, -1)
	pnMain.AddNode(cvPanel, 0,0,TDiam,TDiam)
	pnMain.AddNode(cMold,-1, -1, -1, -1)
	Radius = 75/Scale
	Dim tx As String 
	Dim flg As Boolean 
	DrawPanel

End Sub
Private Sub DrawPanel
    Dim  TickCount As Short
    Dim  Stroke As Short
    Dim  strk(4) As Double
	strk(0)= 13/Scale
	strk(1)= 28/Scale
	strk(2)= 7/Scale
	strk(3)= 25/Scale	
	Dim fz As Double = (11/Scale) 
	Dim fz1 As Double = (13/Scale) 
	Dim f As Font = fx.CreateFont("System", fz,False,False)
	Dim f1 As Font = fx.CreateFont("System", fz1,True,False)
	Dim NewPt(2) As PointApi 
	Dim Radius As Double  = 95/Scale
	cRadar = 66/Scale
	For TickCount = 0 To 359 
		NewPt(0)= new_pt(TickCount,Radius,Center,Center)
    	Stroke = TickCount Mod 10
        If Stroke = 0 Then 
			If (TickCount/10)Mod 2 <>0 Then
				NewPt(1) = new_pt(TickCount,Radius - strk(1),Center,Center)
			Else
				NewPt(1) = new_pt(TickCount,Radius - strk(0),Center,Center)
			End If
			cvPanel.DrawLine(NewPt(0).x, NewPt(0).y ,NewPt(1).x,NewPt(1).y,fx.Colors.DarkGray,0.5)
		Else If TickCount Mod 2 = 0 Then
			NewPt(1) = new_pt(TickCount,Radius - strk(2),Center,Center)
			cvPanel.DrawLine(NewPt(0).x, NewPt(0).y ,NewPt(1).x,NewPt(1).y,fx.Colors.DarkGray,0.5)
		End If
        Stroke = TickCount Mod 20
        If Stroke = 0 Then
			NewPt(1) = new_pt(360-TickCount,Radius - strk(3),Center,Center)
			cvPanel.DrawTextRotated(TickCount, NewPt(1).x , NewPt(1).y, f, fx.Colors.DarkGray, "CENTER", TickCount)
		End If
	Next
	cvPanel.DrawCircle(Center,Center,cRadar,RadarColor,True,0)
	Dim g As Int = 0 
	f  = fx.CreateFont("System", 9/Scale,False,False)
	For TickCount= 0 To 5
		Stroke = (66-11 * TickCount)/Scale
		cvPanel.DrawCircle(Center,Center,Stroke, fx.Colors.LightGray,False,0.5)
		NewPt(0) = new_pt(330,Stroke,Center,Center)
		If g>0 Then cvPanel.DrawTextRotated(g & "°", NewPt(0).X, NewPt(0).Y, f, fx.Colors.white,"LEFT", 30)
		g = g + 15
	Next
	Dim r As Double = cRadar
	NewPt(0) = new_pt(330,r,Center,Center)
	cvPanel.DrawLine(Center,Center, NewPt(0).X, NewPt(0).Y, fx.Colors.LightGray,0.5)
	cvPanel.DrawLine(Center-cRadar,Center, Center+cRadar,Center, fx.Colors.LightGray,0.5)
	cvPanel.DrawLine(Center,Center-cRadar, Center, Center+cRadar, fx.Colors.LightGray,0.5)
	For i=0 To mSat - 1
		pnMain.AddNode(lbSat(i),0,0,-1,-1)
	Next	
End Sub
Public Sub showSatellites(frm As Form, lft As Int, Tp As Int)
	frm.RootPane.AddNode(pnMain,lft , Tp, -1, -1)
	
End Sub
Private Sub new_pt(nAngle As Double, r As Double, CX  As Double, CY As Double ) As PointApi 
        Dim AngleRad As Double
		Dim pt As PointApi 
		nAngle = 90 + nAngle
        If nAngle > 360 Then nAngle = nAngle - 360
        AngleRad = nAngle * cPI / 180 'convert to rad
        If AngleRad < 0 Then AngleRad = 6.283 + AngleRad
        pt.x = CX + (r) * Cos(AngleRad)
        pt.Y  = CY - (r) * Sin(AngleRad)
        Return pt
End Sub
