﻿Type=Class
Version=2.8
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private pnMain As Pane
	Private cWdt, cHgt As Double
	Private mSat As Short
	Private pnSignal() As Pane
	Private lbSatNumber() As Label
	Private ScaleW As Double 
	Private ScaleH As Double 
	Private strColor(5) As String
	Private PnBackColor As Paint 
	Private TxtForecolor As Paint
	Private BdColor As Paint
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Wdt As Double, Hgt As Double, maxSat As Short)
	cWdt = Wdt
	cHgt = Hgt
	ScaleW= 250/cWdt
	ScaleH = 250/cHgt	
	mSat = maxSat
	Dim pnSignal(mSat) As Pane
	Dim lbSatNumber(mSat) As Label
	pnMain.Initialize("")
	For i = 0 To mSat-1
		lbSatNumber(i).Initialize("")
		pnSignal(i).Initialize("")
	Next	
	strColor(0)  = "#00FF00"
	strColor(1) = "#40BF00"
	strColor(2) = "#808000"
	strColor(3) = "#BF4000"
	strColor(4) = "#FF0000"		
	PnBackColor = fx.Colors.White  
	TxtForecolor = fx.Colors.DarkGray 
	BdColor = fx.Colors.DarkGray 
	makeSignal
End Sub
Private Sub makeSignal 
	Dim f As Font = fx.CreateFont("Arial", 10, True, False)
	Dim wdt,  hgt As Int
	wdt = (cWdt / 12/ScaleW)-2
	hgt = cHgt
	setColors(PnBackColor, BdColor, TxtForecolor)
	For i = 0 To mSat-1
		lbSatNumber(i).Font = f
		lbSatNumber(i).Style="-fx-alignment: center;-fx-border-color: #a0a0a0;"
		lbSatNumber(i).TextColor = fx.Colors.DarkGray 
		pnSignal(i).Style="-fx-border-color: #a0a0a0;"
		pnMain.AddNode(lbSatNumber(i),1+i*(wdt+2), hgt-20,wdt, -1)
		pnMain.AddNode(pnSignal(i),1+i*(wdt+2),hgt- 27,wdt, 2)
	Next		
End Sub
Public Sub showSignal(frm As Form, lft As Int, Tp As Int)
	frm.RootPane.AddNode(pnMain,lft , Tp, -1, -1)
End Sub
Public Sub setColors(PanelBackColor As Paint, BordersColor As Paint, TextForeColor As Paint )
	PnBackColor =  PanelBackColor
	BdColor = BordersColor
	TxtForecolor = TextForeColor
	Dim RGB(4) As Int = getRGB(fx.Colors.To32Bit(PnBackColor))
	Dim Alpha As Double = RGB(0)/255
	Dim st As String 
	Dim stStr As String = "rgba("
	Dim stStrB As String = "rgba("
	For i = 1 To 3
		stStr = stStr & RGB(i) & ", "
	Next
	stStr = stStr & Alpha & ")"
	Dim RGB(4) As Int = getRGB(fx.Colors.To32Bit(BdColor))
	Alpha = RGB(0)/255
	For i = 1 To 3
		stStrB = stStrB & RGB(i) & ", "
	Next	
	stStrB = stStrB & Alpha & ")"
	pnMain.Style = "-fx-background-color: " & stStr & ";-fx-border-color: " & stStrB & ";"
	For i = 0 To mSat-1
		lbSatNumber(i).Style="-fx-alignment: center;-fx-border-color: " & stStrB & ";"
		lbSatNumber(i).TextColor = TxtForecolor
	Next
End Sub
Public Sub setValue(satelliteNumber As Short, pseudoRandomCode As Short, signalToNoiseRatio As Short)
	'signalToNoiseRatio 0 to 99
	satelliteNumber=satelliteNumber-1
	signalToNoiseRatio  = Max(Min(99, signalToNoiseRatio),0)
	Dim clr As Short = Abs((signalToNoiseRatio+1)-100)/20
	If clr>4 Then clr = 4
	If signalToNoiseRatio=0 Then
		lbSatNumber(satelliteNumber).Text = ""
		pnSignal(satelliteNumber).PrefHeight = 2
		pnSignal(satelliteNumber).Top = cHgt-27
	Else
		lbSatNumber(satelliteNumber).Text = pseudoRandomCode
		pnSignal(satelliteNumber).PrefHeight  = (cHgt-27)/99 * signalToNoiseRatio
		pnSignal(satelliteNumber).Top= cHgt-(25+pnSignal(satelliteNumber).PrefHeight)
		pnSignal(satelliteNumber).Style="-fx-background-color:  linear-gradient(to top, " & strColor(4) & ", " & strColor(clr) & ");"
	End If
End Sub
Public Sub getRGB(rgb_Clr As Int) As Int()
    Dim res(4) As Int
    res(0) = Bit.UnsignedShiftRight(Bit.AND(rgb_Clr, 0xff000000), 24)	'Alpha
    res(1) = Bit.UnsignedShiftRight(Bit.AND(rgb_Clr, 0xff0000), 16)		'Red
    res(2) = Bit.UnsignedShiftRight(Bit.AND(rgb_Clr, 0xff00), 8)		'Green
	res(3) = Bit.AND(rgb_Clr, 0xff)										'Blue
    Return res 
End Sub